# Microblog

## A - Lessons

1. [Initiatie Docker](https://youtu.be/-iBQxXHRnHg)
2. [Installatie Slim](https://youtu.be/fjKTdo9RTDs)
3. [Slim eerste stappen](https://youtu.be/7DgeCaiB5tQ)
4. [POST en Debugging](https://youtu.be/cotqB5U6qLg)
5. [POST en GET Routes](https://youtu.be/l-3kF5xRzas)
6. [POST/GET mep any routes en routeparams](https://youtu.be/axQha1RVnf8)
7. [Start BLOG project](https://youtu.be/kaYlrMcg0O0)
8. [Blog build-up](https://youtu.be/_-C3T57tpS8)
9. [Add blog post](https://youtu.be/IKUmsY9AFkM)
10. [SQL Injection](https://youtu.be/VawAKqLb9o4)
11. [Namespaces](https://youtu.be/-RZEaAlMux0)
12. [Namespaces toepassing](https://youtu.be/xElWefiIV_o)
13. [Twig to module](https://www.youtube.com/watch?v=kPe29anSbzE&list=PLhlDbeB0Fznx6iTGsvCtHqP3aFI--COm7&index=7)
14. [Twig templates](https://www.youtube.com/watch?v=MWkkS08_E9Y&list=PLhlDbeB0Fznx6iTGsvCtHqP3aFI--COm7&index=6)

## B - Basic Commands Docker

### B1 - Use composer

```powershell
docker run --rm -t -i -v ${PWD}:/app debaetsr/composer2 <the rest of the command>
```

### B2 - Install Slim

1. Create a new folder

2. Install Slim 4

```powershell
docker run --rm -t -i -v ${PWD}:/app debaetsr/composer2 require slim/slim:"4.\*"
```

3. Install PSR-7 implementation for use with Slim 4

```powershell
docker run --rm -t -i -v ${PWD}:/app debaetsr/composer2 require slim/psr7
```

3. Install Twig 3

```powershell
docker run --rm -t -i -v ${PWD}:/app composer require "twig/twig:^3.0"
```

4. Modify composer.json by adding the following just before the last parenthesis

```json
"config": {
"platform-check": false
}
```

5. Update Composer2

```powershell
docker run --rm -t -i -v ${PWD}:/app debaetsr/composer2 update
```

### B3 - Start PHP

```powershell
docker run --rm -t -i -v ${PWD}:/src -p 8080:8000 debaetsr/php_xdebug
```

### B4 - Use Debug

1. If necessary, create a new launch.json file, and replace (or add) the "Listen for XDebug" with the following (note parentheses and commas):

```json
{
"name": "Listen for XDebug",
"type": "php",
"request": "launch",
"port": 9003,
"pathMappings": { "/src": "${workspaceRoot}" }
},
```

2. The first time when debugging, add this in the URL

```txt
?XDEBUG_SESSION_START=1
```

### B5 - Other

```powershell
php -S 0.0.0.0:8000 -t public
```
